#
# Cpu
#
# Author: Christoph Kappel
# Contact: unexist@dorfelite.net
# Description: Show the cpu usage
# Version: 0.1
# Date: Mon May 18 21:00 CET 2009
# $Id: dist/sublets/cpu.rb,v 1367 2009/08/27 22:44:53 unexist $
#

class Cpu < Subtle::Sublet
  attr_accessor :cpus, :sum, :last, :delta

  def initialize
    self.interval = 30
    @cpus         = 0
    @last         = []
    @delta        = []
    @sum          = []

    # Init and count CPUs
    begin
      file = IO.readlines("/proc/stat").join

      file.scan(/cpu(\d+)/) do |num| 
        n         = num.first.to_i
        @cpus    += 1
        @last[n]  = 0
        @delta[n] = 0
        @sum[n]   = 0
      end
    rescue
      raise "Init error"
    end
  end

  def run
    begin
      data = ""
      time = Time.now.to_i
      file = IO.readlines("/proc/stat").join

      file.scan(/cpu(\d+) (\d+) (\d+) (\d+)/) do |num, user, nice, system| 
        n         = num.first.to_i
        @delta[n] = time - @last[n]
        @delta[n] = 1 if(0 == @delta[n])
        @last[n]  = time

        sum       = user.first.to_i + nice.first.to_i + system.first.to_i
        use       = ((sum - @sum[n]) / @delta[n] / 100.0)
        @sum[n]   = sum
        percent   = (use * 100.0).ceil % 100

        data << percent.to_s + "% "
      end

      self.data = data + " | "
    rescue => err # Sanitize to prevent unloading
      self.data = "subtle"
      p err
    end  
  end
end
