#
# Storage
#
# Author: Christoph Kappel
# Contact: unexist@dorfelite.net
# Description: Show the storage usage
# Version: 0.1
# Date: Mon May 18 21:00 CET 2009
# $Id: dist/sublets/storage.rb,v 1301 2009/07/29 18:33:06 unexist $
#

class Storage < Subtle::Sublet
  attr_accessor :left, :total

  def initialize
    self.interval = 120
    @left         = 0
    @total        = 0
  end

  def run
    report = ""

    begin
      report = `df -h`
      @total, @left = report.match(/([0-9.]+.)\s+[0-9.]+.\s+([0-9.]+.)\s+[0-9.]+%\s+\/\s+/).captures

      self.data = @left + "/" + @total + color("#CF6171") + " // "
    rescue => err # Sanitize to prevent unloading
      self.data = "subtle"
      p err
    end
  end
end
